<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>
    <parent>
        <groupId>xyz.ottr.lutra</groupId>
        <version>0.6.13-SNAPSHOT</version>
        <artifactId>lutra</artifactId>
        <relativePath>../pom.xml</relativePath>
    </parent>

    <artifactId>lutra-core</artifactId>
    <packaging>jar</packaging>

    <name>${project.groupId}:${project.artifactId}</name>

    <dependencies>

        <dependency>
            <groupId>org.apache.jena</groupId>
            <artifactId>jena-core</artifactId>
        </dependency>

        <dependency>
            <groupId>org.apache.jena</groupId>
            <artifactId>jena-arq</artifactId>
        </dependency>

        <!-- Apache commons -->
        <dependency>
            <groupId>org.apache.commons</groupId>
            <artifactId>commons-collections4</artifactId>
        </dependency>
        <dependency>
            <groupId>org.apache.commons</groupId>
            <artifactId>commons-math3</artifactId>
        </dependency>
        <dependency>
            <groupId>commons-io</groupId>
            <artifactId>commons-io</artifactId>
        </dependency>
        <dependency>
            <groupId>commons-validator</groupId>
            <artifactId>commons-validator</artifactId>
        </dependency>

        <dependency>
            <groupId>org.hamcrest</groupId>
            <artifactId>hamcrest</artifactId>
        </dependency>

        <dependency>
            <groupId>net.sf.saxon</groupId>
            <artifactId>Saxon-HE</artifactId>
            <version>10.6</version>
        </dependency>

    </dependencies>

    <build>
        <plugins>

            <plugin>
                <groupId>com.googlecode.maven-download-plugin</groupId>
                <artifactId>download-maven-plugin</artifactId>
                <executions>
                    <execution>
                        <id>download-types</id>
                        <phase>generate-sources</phase>
                        <goals>
                            <goal>wget</goal>
                        </goals>
                        <configuration>
                            <url>https://spec.ottr.xyz/rOTTR/0.2/types.owl.ttl</url>
                            <outputFileName>types.owl.ttl</outputFileName>
                            <outputDirectory>${project.basedir}/src/main/resources</outputDirectory>
                            <!--md5>MD5 SUM HERE</md5 -->
                            <skipCache>true</skipCache>
                        </configuration>
                    </execution>
                    <execution>
                        <id>download-puntypes</id>
                        <phase>generate-sources</phase>
                        <goals>
                            <goal>wget</goal>
                        </goals>
                        <configuration>
                            <url>https://spec.ottr.xyz/rOTTR/0.2/puntypes.owl.ttl</url>
                            <outputFileName>puntypes.owl.ttl</outputFileName>
                            <outputDirectory>${project.basedir}/src/main/resources</outputDirectory>
                            <!--md5>MD5 SUM HERE</md5 -->
                            <skipCache>true</skipCache>
                        </configuration>
                    </execution>
                </executions>
            </plugin>

            <plugin>
                <artifactId>plantuml-generator-maven-plugin</artifactId>
                <groupId>de.elnarion.maven</groupId>
                <executions>
                    <execution>
                        <id>lutra</id>
                        <goals>
                            <goal>generate</goal>
                        </goals>
                        <phase>generate-test-sources</phase>
                        <configuration>
                            <outputFilename>lutra-core_all.puml</outputFilename>
                            <hideFields>true</hideFields>
                            <hideMethods>true</hideMethods>
                            <scanPackages>
                                <scanPackage>
                                    xyz.ottr.lutra
                                </scanPackage>
                            </scanPackages>
                        </configuration>
                    </execution>
                    <execution>
                        <id>lutra.model</id>
                        <goals>
                            <goal>generate</goal>
                        </goals>
                        <phase>generate-test-sources</phase>
                        <configuration>
                            <outputFilename>lutra-model.puml</outputFilename>
                            <hideFields>true</hideFields>
                            <hideMethods>true</hideMethods>
                            <scanPackages>
                                <scanPackage>
                                    xyz.ottr.lutra.model
                                </scanPackage>
                            </scanPackages>
                        </configuration>
                    </execution>
                    <execution>
                        <id>lutra.store</id>
                        <goals>
                            <goal>generate</goal>
                        </goals>
                        <phase>generate-test-sources</phase>
                        <configuration>
                            <outputFilename>lutra-store.puml</outputFilename>
                            <hideFields>true</hideFields>
                            <hideMethods>true</hideMethods>
                            <scanPackages>
                                <scanPackage>
                                    xyz.ottr.lutra.store
                                </scanPackage>
                            </scanPackages>
                        </configuration>
                    </execution>
                    <execution>
                        <id>lutra.system</id>
                        <goals>
                            <goal>generate</goal>
                        </goals>
                        <phase>generate-test-sources</phase>
                        <configuration>
                            <outputFilename>lutra-system.puml</outputFilename>
                            <hideFields>true</hideFields>
                            <hideMethods>true</hideMethods>
                            <scanPackages>
                                <scanPackage>
                                    xyz.ottr.lutra.system
                                </scanPackage>
                            </scanPackages>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
        </plugins>
    </build>
</project>
